<?php
#
# Script         Quick and Dirty File Download
# Copyright      2013 Denny Schlesinger
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
# Autor          Denny Schlesinger
#
# $Id: $
#
############################################################################

if ($_SERVER['REQUEST_METHOD'] == "POST") {

    switch ($_POST['action']) {
    case 'download':
        if(!isset($_POST['files'])) {
            echo "No files were selected<br><br>\n";
            break;
        } elseif(count($_POST['files']) == 1) {
            $mimeTypes = array(
                'htm' => 'text/html',
                'html' => 'text/html',
                'asp' => 'text/html',
                'aspx' => 'text/html',
                'css' => 'text/css',
                'sql' => 'text/plain',
                'txt' => 'text/plain',
                'doc' => 'application/msword',
                'exe' => 'application/octet-stream',
                'js' => 'application/javascript',
                'pdf' => 'application/pdf',
                'php' => 'application/x-httpd-php',
                'ppt' => 'application/vnd.ms-powerpoint',
                'xls' => 'application/vnd.ms-excel',
                'zip' => 'application/zip',
                'gif' => 'image/gif',
                'jpg' => 'image/jpg',
                'jpeg' => 'image/jpg',
                'png' => 'image/png'
            );
            $file = $_POST['files'][0];
            $path_parts = pathinfo($file);
            $mime = $mimeTypes[$path_parts['extension']];
            
            // push to download the file
            header('Content-type: {$mime}');
            header('Content-Disposition: attachment; filename="'.$file.'"');
            readfile($file);
            
        } else {
        
            $archive = "file_archive.zip";
            $zipname = "__{$archive}";
            $zip = new ZipArchive();
            if ($zip->open($zipname, ZIPARCHIVE::CREATE) !== TRUE) {
                trigger_error("Cannot open <$zipname>\n", E_USER_ERROR);
            }
            foreach($_POST['files'] AS $file) {
                $zip->addFile($file);
            }
            $zip->close();
            $content = file_get_contents($zipname);
            unlink($zipname);
            // push to download the zip
            header('Content-type: application/zip');
            header('Content-Disposition: attachment; filename='.$archive);
            echo $content;
        }
        break;
        
    case 'cancel':
        break;
        
    } // switch ($_POST['action'])
}

?>
<!DOCTYPE html>
<html>
<head>
  <title>Quick and Dirty File Download</title> 
  <meta http-equiv="content-type" content="text/html; charset=iso-8859-1">  
  <meta name="description" content="Quick and Dirty File Download: Download one or more files from the current directory.">
  <!--  Copyright (c) 2013 by Denny Schlesinger --> 
</head>
<body>
<form enctype="multipart/form-data" action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
<fieldset style="width:250px;">
<legend>Select files to download</legend>
<select id="files" name="files[]" multiple>
<?php

// get the file names in the current directory
// to build the <select> tag
$dir = opendir(getcwd());
//loop through all the files
$files = array();
while ($file = readdir($dir)) {
    // ignore system files AND
    // ignore files starting with underscore (_file.xxx)
    if(strpos ($file, '.') !== 0 AND
       strpos ($file, '_') !== 0) { 
        $files[] = $file;
    }
}
// order file names
sort($files);
// create <option> tags
foreach ($files AS $file) {
    // echo file name
    $option = "<option label={$file} value={$file}>{$file}</option>";
    echo "$option>\n";
}

?>
</select><br>
<button type="submit" id="download" name="action" value="download">Download</button>
<button type="reset">Reset</button>
<button type="submit" id="cancel" name="action" value="cancel">Cancel</button>
</fieldset>
</form>
<br><br>
<div>
<a href="../qd+downloads.tgz">Download Quick and Dirty File Download</a>
</div>
</body>
</html>
